<?php

// ------------------------------------------------------------------------- //
// Les Visiteurs - Statistiques de frquentation d'un site web               //
// ------------------------------------------------------------------------- //
// Visitors      - Web site statistics analysis program                      //
// ------------------------------------------------------------------------- //
// Copyright (C) 2000, 2001  J-Pierre DEZELUS <jpdezelus@phpinfo.net>        //
// ------------------------------------------------------------------------- //
//                   phpInfo.net <http://www.phpinfo.net/>                   //
// ------------------------------------------------------------------------- //
//  This program is free software; you can redistribute it and/or modify     //
//  it under the terms of the GNU General Public License as published by     //
//  the Free Software Foundation; either version 2 of the License, or        //
//  (at your option) any later version.                                      //
//                                                                           //
//  This program is distributed in the hope that it will be useful,          //
//  but WITHOUT ANY WARRANTY; without even the implied warranty of           //
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            //
//  GNU General Public License for more details.                             //
//                                                                           //
//  You should have received a copy of the GNU General Public License        //
//  along with this program; if not, write to the Free Software              //
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA //
// ------------------------------------------------------------------------- //

extract($_GET);

if (!defined("_CONFIG_LV_PHP"))
{
    define("_CONFIG_LV_PHP", 1);

// ------------------------ general Configuration -------------------------- //

    // language
    if (!$ignore_messages)
    {
        include($lvc_include_dir.'lang/french.inc.php');
    }

    // database abstraction
    require($lvc_include_dir.'db/db_mysql.inc.php');

    // lvp config
    $lvp_default_mode = "all"; // all, nb, sig
    $lvp_default_type = "vis"; // vis, hits

    // database connection
    $lvc_db_host     = 'localhost';
    $lvc_db_user     = 'root';
    $lvc_db_password = '';
    $lvc_db_database = 'infobidouille';

    // tables
    $lvc_table_visitors = 'visiteurs';
    $lvc_table_archives = 'archives';
    $lvc_table_domains  = 'domaines';

    // your parameters (for graphs and titles)
    $lvc_site_name   = 'Infobidouille.com';  // like 'phpInfo.net' or 'My Web'

    // site opening
    $lvc_site_opening_year  = 2006; // for last months statistics
    $lvc_site_opening_month = 05;

    // directories & files
    $lvc_admin_dir   = 'admin';
    $lvc_cache_dir   = $lvc_include_dir.'caches';
    $lvc_modules_dir = $lvc_include_dir.'modules';
    
    // ADMIN file
    $lvc_admin_file = 'admin.php3';

    // CSS file
    $lvc_css_file   = 'css/visiteurs.css';

    // version
    $lvc_version = '3.0 Beta';
    
    // view admin menu on main page
    $lvc_view_admin_menus = false;
    
    // php | php3 | ...
    $lvc_php_extension = 'php3'; // for image-vis script call

// ------------------------------------------------------------------------- //
    

// ------------------------ new-visitor Configuration ----------------------- //
    // cookie
    $lvc_cookie_name      = 'ibd_lvc'; // change it ! (no space, no accent)
    
    $lvc_ignore_referers[] = 'domain.tld'; // no / at end
        
    $lvc_remove_referers[] = 'infobidouille.com';
    $lvc_remove_referers[] = 'xsetup.net';
    
    // machines to ignore
    $lvc_ignore_machines[] = '82.67.66.40';
    $lvc_ignore_machines[] = '127.0.0.1';

    // servers to ignore
    $lvc_ignore_servers[]  = 'xxx.xxx.xxx.xxx';
    //$lvc_ignore_servers[]  = 'localhost';

    $lvc_between_2_visits = 100; // > 0 (0 => record all visits, dangerous !!!)
    $lvc_agent_max_length = 100;
    
    $lvc_log_file = 'visiteurs.log';

// ------------------------------------------------------------------------- //


// ------------------------ caches Configuration --------------------------- //
    
    //   900 = 15 mn
    //  3600 =  1 hour
    // 86400 =  1 day

    $lvc_default_cache_delay    = 6;
    
    $lvc_delay_archive_month    = 6;
    $lvc_delay_calendar         = 6;
    $lvc_delay_daily_stats      = 6;
    $lvc_delay_current_month    = 6;
    $lvc_delay_img_day_per_hour = 6;
    $lvc_delay_img_last_months  = 6;
    $lvc_delay_img_year_per_day = 6;
    $lvc_delay_last_months      = 6;
    $lvc_delay_last_visitors    = 6;
    $lvc_delay_top_day_referer  = 6;

    $lvc_display_cache_delay    = 1;  // 0 | 1

// ------------------------------------------------------------------------- //


// ------------------------ graphs Configuration --------------------------- //

    $lvc_images_format = 'png'; // gif | png

    $lvc_base_img_last_months  = 10;
    $lvc_base_img_day_per_hour = 10;
    $lvc_base_img_per_hour     = 10;
    $lvc_base_img_per_day      = 10;
    $lvc_base_img_year_per_day = 10;

    $lvc_pattern_last_months  = 'histo24';
    $lvc_pattern_day_per_hour = 'histo16';
    $lvc_pattern_per_hour     = 'histo16';
    $lvc_pattern_per_day      = 'histo8';

    // hexa colors
    $lvc_color_bg_out   = '354785';
    $lvc_color_bg_in    = 'DEDEE0';
    $lvc_color_maxvalue = '1A28DF';
    $lvc_color_minvalue = 'FB0006';
    $lvc_color_value    = '5A6BA5';
    $lvc_color_bar_h    = 'D0D1D4';
    $lvc_color_cache    = 'A8B9FA';
    $lvc_color_title    = 'FCFC99';
    $lvc_color_month_0  = '0B1A50';
    $lvc_color_month_1  = '354785';

// ------------------------------------------------------------------------- //
    

// ------------------------ visitors Configuration ------------------------- //

    $lvc_nb_last_visitors   = 30;
    $lvc_nb_last_months     =  6;
    $lvc_nb_months_calendar = 12;
    $lvc_nb_top_visitors    = 20;
    $lvc_nb_top_agent_os    = 10;
    $lvc_nb_top_referer     = 30;
    $lvc_nb_top_domain      = 30;

    $lvc_hide_IP = true;

// ------------------------------------------------------------------------- //



// ------------------------ agents/OS Configuration ------------------------ //

    $lvc_OS_IHM = Array(
        'Win95' => 'Windows 9x/ME',
        'WinMe' => 'Windows 9x/ME',
        'Win98' => 'Windows 9x/ME',
        'Win2000' => 'Windows 2000',
        'WinXP' => 'Windows XP',
        'Win2003' => 'Windows 2003',
        'WinVista' => 'Windows Vista',
        'WinNT' => 'Windows NT',
        'Mac PPC' => 'Mac OS',
        'MacX PPC' => 'Mac OS X PPC',
        'MacX Intel' => 'Mac OS X Intel',
        'Linux' => 'Linux',
        'SunOS' => 'Unix',
        'FreeBSD' => 'BSD',
        'AIX' => 'Unix',
        'IRIX' => 'Unix',
        'HP-UX' => 'Unix',
        'OS/2' => 'OS/2',
        'NetBSD' => 'BSD',
        'WinCE' => 'Windows CE'
    );

    $lvc_OS = Array(
        'Win95' => 'Windows 95',
        'WinMe' => 'Windows ME',
        'Win98' => 'Windows 98',
        'Win2000' => 'Windows 2000',
        'WinXP' => 'Windows XP',
        'Win2003' => 'Windows 2003',
        'WinVista' => 'Windows Vista',
        'WinNT' => 'Windows NT',
        'Mac PPC' => 'Mac OS',
        'MacX PPC' => 'Mac OS X PPC',
        'MacX Intel' => 'Mac OS X Intel',
        'Linux' => 'Linux',
        'SunOS' => 'SunOS',
        'FreeBSD' => 'FreeBSD',
        'AIX' => 'AIX',
        'IRIX' => 'IRIX',
        'HP-UX' => 'HP-UX',
        'OS/2' => 'OS/2',
        'NetBSD' => 'NetBSD',
        'WinCE' => 'Windows CE'    
    );

    $lvc_agent['Internet Explorer'] = 'IE;';
    $lvc_agent['Netscape']          = 'NS;';
    $lvc_agent['Firefox']           = 'FF;';
    $lvc_agent['Opera']             = 'OP;';
    $lvc_agent['Safari']            = 'SA;';

    $lvc_other_agt['Lynx']      = 'Lynx - Linux';
    $lvc_other_agt['WWWOFFLE']  = 'WWWOFFLE - Linux';
    $lvc_other_agt['Konqueror'] = 'Konqueror - Linux';
    $lvc_other_agt['Avant Browser'] = 'Avant Browser - Windows';
    $lvc_other_agt['portalmmm'] = 'Mobile i-Mode';
    $lvc_other_agt['AvantGo'] = 'AvantGo - FreeBSD';
    $lvc_other_agt['SeaMonkey'] = 'SeaMonkey';
    $lvc_other_agt['Camino'] = 'Camino';

    $lvc_other_agt['DnloadMage'] = 'DnloadMage(BOT)';
    $lvc_other_agt['Arachmo'] = 'Arachmo (BOT)';
    $lvc_other_agt['MS FrontPage 6.0'] = 'MS FrontPage 6.0 (BOT)';
    $lvc_other_agt['T-H-U-N-D-E-R-S-T-O-N-E'] = 'T-H-U-N-D-E-R-S-T-O-N-E (BOT)';
    $lvc_other_agt['Check&Get'] = 'Check&Get (BOT)';
    $lvc_other_agt['Powermarks'] = 'Powermarks (BOT)';
    $lvc_other_agt['Yahoo! Slurp'] = 'Yahoo! Slurp (BOT)';
    $lvc_other_agt['Yahoo-MMCrawler'] = 'Yahoo! MMCrawler (BOT)';
    $lvc_other_agt['Googlebot'] = 'GoogleBot (BOT)';
    $lvc_other_agt['Google-Sitemaps'] = 'Google-Sitemaps (BOT)';
    $lvc_other_agt['msnbot'] = 'MSNBot (BOT)';
    $lvc_other_agt['yoono'] = 'Yoono Web-crawler (BOT)';
    $lvc_other_agt['Xenu Link Sleuth'] = 'Xenu Link Sleuth (BOT)';
    $lvc_other_agt['petitsage'] = 'Petitsage Site Detector (BOT)';
    $lvc_other_agt['adressendeutschland'] = 'Adressen Deutschland (BOT)';
    $lvc_other_agt['Wget'] = 'Wget (BOT)';
    $lvc_other_agt['WebCopier'] = 'WebCopier (BOT)';
    $lvc_other_agt['Mediapartners-Google'] = 'Mediapartners-Google (BOT)';
    $lvc_other_agt['ichiro'] = 'Ichiro (BOT)';
    $lvc_other_agt['Exabot'] = 'Exabot (BOT)';
    $lvc_other_agt['SurveyBot'] = 'SurveyBot (BOT)';
    $lvc_other_agt['UtilMind HTTPGet'] = 'UtilMind HTTPGet (BOT)';
    $lvc_other_agt['DA 7'] = 'Donwload Accelerator (BOT)';
    $lvc_other_agt['Cherchonsbot'] = 'Cherchonsbot (BOT)';
    $lvc_other_agt['Snapbot'] = 'Snapbot (BOT)';
    $lvc_other_agt['MJ12bot'] = 'MJ12bot (BOT)';
    $lvc_other_agt['Search Engine Optimizer Bot'] = 'Search Engine Optimizer Bot (BOT)';
    $lvc_other_agt['FurlBot'] = 'FurlBot (BOT)';
    $lvc_other_agt['ZyBorg'] = 'ZyBorg (BOT)';
    $lvc_other_agt['troovziBot '] = 'troovziBot (BOT)';
    $lvc_other_agt['MQbot'] = 'MQbot (BOT)';
    $lvc_other_agt['Gigabot'] = 'Gigabot (BOT)';
    $lvc_other_agt['BecomeBot'] = 'BecomeBot (BOT)';
    $lvc_other_agt['aipbot'] = 'aipbot (BOT)';
    $lvc_other_agt['psbot'] = 'psbot (BOT)';
    $lvc_other_agt['schibstedsokbot'] = 'schibstedsokbot (BOT)';
    $lvc_other_agt['boitho.com'] = 'boitho.com (BOT)';
    $lvc_other_agt['Seekbot'] = 'Seekbot (BOT)';
    $lvc_other_agt['PageBitesHyperBot'] = 'PageBitesHyperBot (BOT)';
    $lvc_other_agt['OutfoxBot'] = 'OutfoxBot (BOT)';
    $lvc_other_agt['IRLbot'] = 'IRLbot (BOT)';
    $lvc_other_agt['LocalcomBot'] = 'LocalcomBot (BOT)';
    $lvc_other_agt['NutchCVS'] = 'NutchCVS (BOT)';
    $lvc_other_agt['SuperBot'] = 'SuperBot (BOT)';
    $lvc_other_agt['MyFamilyBot'] = 'MyFamilyBot (BOT)';
    $lvc_other_agt['TurnitinBot'] = 'TurnitinBot (BOT)';
    $lvc_other_agt['kakle-spider'] = 'kakle-spider (BOT)';
    $lvc_other_agt['DepSpid'] = 'DepSpid (BOT)';
    $lvc_other_agt['hl_ftien_spider'] = 'hl_ftien_spider (BOT)';
    $lvc_other_agt['ScSpider'] = 'ScSpider (BOT)';
    $lvc_other_agt['toCrawl'] = 'toCrawl (BOT)';
    $lvc_other_agt['Syntryx ANT Scout Chassis Pheromone'] = 'Syntryx ANT Scout Chassis Pheromone (BOT)';
    $lvc_other_agt['Accoona-AI-Agent'] = 'Accoona-AI-Agent (BOT)';
    $lvc_other_agt['Dimoitou'] = 'Dimoitou (BOT)';
    $lvc_other_agt['Shim-Crawler'] = 'Shim-Crawler (BOT)';
    $lvc_other_agt['BeijingCrawler'] = 'BeijingCrawler';
    $lvc_other_agt['findlinks'] = 'findlinks (BOT)';
    $lvc_other_agt['Project Kolinka Forum Search'] = 'Project Kolinka Forum Search (BOT)';
    $lvc_other_agt['FavIconizer'] = 'FavIconizer';
    $lvc_other_agt['ArbeFavIcons'] = 'ArbeFavIcons';
    $lvc_other_agt['FavOrg'] = 'FavOrg';
    $lvc_other_agt['Bookdog'] = 'Bookdog (BOT)';
    $lvc_other_agt['cfetch'] = 'cfetch (BOT)';
    $lvc_other_agt['MVAClient'] = 'MVAClient (BOT)';
    $lvc_other_agt['ia_archiver'] = 'ia_archiver (BOT)';
    $lvc_other_agt['NG/2.0'] = 'Exabot (BOT)';
    $lvc_other_agt['httpclient'] = 'httpclient (BOT)';
    $lvc_other_agt['MSRBOT'] = 'MSRBOT (BOT)';
    $lvc_other_agt['Java'] = 'Java (BOT)';
    $lvc_other_agt['URLBase'] = 'URLBase (BOT)';
    $lvc_other_agt['Blaiz-Bee'] = 'Blaiz-Bee (BOT)';
    $lvc_other_agt['InetURL'] = 'InetURL (BOT)';
    $lvc_other_agt['topicblogs'] = 'topicblogs (BOT)';
    $lvc_other_agt['SBIder'] = 'SBIder (BOT)';
    $lvc_other_agt['STEROID'] = 'STEROID Download (BOT)';
    $lvc_other_agt['libwww-perl'] = 'libwww-perl (BOT)';
    $lvc_other_agt['LWP::Simple'] = 'LWP::Simple (BOT)';
    $lvc_other_agt['larbin'] = 'larbin (BOT)';
    $lvc_other_agt['DiGi-RSSBot'] = 'DiGi-RSSBot (BOT)';
    $lvc_other_agt['Megite'] = 'Megite (BOT)';
    $lvc_other_agt['eMule'] = 'eMule (BOT)';
    $lvc_other_agt['Ask Jeeves'] = 'Ask Jeeves (BOT)';
    $lvc_other_agt['Linkman'] = 'Linkman (BOT)';
    $lvc_other_agt['Netcraft Web Server Survey'] = 'Netcraft Web Server Survey (BOT)';

    $lvc_other_agt['MSIE 6.0'] = 'IE;6.0;WinXP';
    $lvc_other_agt['Trend Micro'] = 'Anonyme';
    $lvc_other_agt['SuperCleaner'] = 'Anonyme';
    $lvc_other_agt['Anonymouse.org'] = 'Anonyme';
    $lvc_other_agt['Steganos Internet Anonym'] = 'Anonyme';
    $lvc_other_agt['Gecko'] = 'Gecko';
    $lvc_other_agt['Mozilla/3.0 (compatible)'] = 'Inconnu';
    $lvc_other_agt['Mozilla/3.01 (compatible;)'] = 'Inconnu';
    $lvc_other_agt['Mozilla/4.0 (compatible;)'] = 'Inconnu';
    $lvc_other_agt['Mozilla/4.0 (Compatible)'] = 'Inconnu';
    $lvc_other_agt['Mozilla/5.0 (compatible;)'] = 'Inconnu';
    $lvc_other_agt['000000000'] = 'Inconnu';

    

//  http://www.psychedelix.com/agents/index.shtml

    $lvc_agent_versions['FF'] = Array(
        '3.0a1',
        '2.0b2',
        '2.0b1',
        '2.0a3',
        '2.0a2',
        '2.0a1',
        '1.5',
        '1.0',
        '0.9.3',
        '0.9.2',
        '0.8'
    );

    $lvc_agent_versions['IE'] = Array(
        '6.0',
        '5.5',
        '5.5b2',
        '5.5b3',
        '5.01',
        '5.0',
        '5.0b1',
        '5.0b2',
        '4.5',
        '4.01',
        '4.0',
        '3.02',
        '3.01'
    );

    $lvc_agent_versions['NS'] = Array(
        '4.76', 
        '4.75', 
        '4.74', 
        '4.73', 
        '4.72', 
        '4.71', 
        '4.7', 
        '4.61', 
        '4.6', 
        '4.51', 
        '4.5', 
        '4.08', 
        '4.07', 
        '4.06', 
        '4.05', 
        '4.04', 
        '4.03'
    );
    
    $lvc_agent_versions['OP'] = Array(
        '9.02',
        '9.01',
        '9.00',
        '8.54',
        '5.12',
        '5.11',
        '5.0',
        '4.0',
        '3.60',
        '3.62'
    );

    $lvc_agent_versions['NS6'] = Array(
        '8.0.3.4',
        '7.1',
        '7',
        '6.2.2',
        '6.1',
        'm14',
        'm17',
        'm18'
    );

    // [$lvc_agent_versions] replaced by [$lvc_agent_versions]

    $lvc_agent_versions_2['NS6'] = Array(
        '8.0.3.4',
        '7.1',
        '7',
        '6.2.2',
        '6.1',
        '6.0',
        '6.0',
        '6.0'
    );

    $lvc_agent_versions['SA'] = Array(
        '419.3',
        '100',
        '417.9.3',
        '312.6',
        '412.5',
        '312.5',
        '412.2.2'
    );

    $lvc_agent_versions_2['SA'] = Array(
        '2.0.4',
        '100',
        '417.9.3',
        '312.6',
        '412.5',
        '312.5',
        '412.2.2'
    );

    $lvc_agent_os = Array(
        'Windows CE'     => 'WinCE',
        'Windows 95'     => 'Win95',
        'Win32'          => 'Win95',
        'Win 9x 4.90'    => 'WinMe',
        'Windows ME'     => 'WinMe',
        'Win98'          => 'Win98',
        'Windows 98'     => 'Win98',
        'Windows NT 5.0' => 'Win2000',
        'Windows NT 5.1' => 'WinXP',
        'Windows NT 5.2' => 'Win2003',
        'Windows NT 6.0' => 'WinVista',
        'Windows NT'     => 'WinNT',
        'Mac PowerPC'    => 'Mac PPC',
        'Mac PPC'        => 'Mac PPC',
        'PPC Mac OS X'   => 'MacX PPC',
        'Intel Mac OS X' => 'MacX Intel',
        'Windows XP'     => 'WinXP',
        'Win XP'         => 'WinXP',
        'Win95'          => 'Win95',
        'WinNT'          => 'WinNT',
        'Linux'          => 'Linux',
        'SunOS'          => 'SunOS',
        'PPC'            => 'Mac PPC',
        'FreeBSD'        => 'FreeBSD',
        'AIX'            => 'AIX',
        'IRIX'           => 'IRIX',
        'HP-UX'          => 'HP-UX',
        'OS/2'           => 'OS/2',
        'NetBSD'         => 'NetBSD',
        'Mac_PowerPC Mac OS X' => 'Mac OS X PPC',
        'Windows 2000'   => 'Win2000'
    );

    
    // ------------------------------------------------------------------------
    // extract agent from $HTTP_USER_AGENT ($agt)
    // ------------------------------------------------------------------------
    function analyse_agent($agt, $debug = 0)
    {
        global $lvc_agent_max_length;
        global $lvc_agent_versions;
        global $lvc_agent_versions_2;
        global $lvc_agent_os;
        global $lvc_other_agt;

        $agt = strtr($agt, '+', ' ');
        $new_agt = "I";

        if ($agt == "I") {
            return $agt;
        }

        if (ereg('Safari', $agt))  // Safari
        {
            $new_agt = 'SA';
            $agt = ereg_replace('Mozilla/[0-9]\.[0-9]', 'Mozilla', $agt);

            for ($cnt = 0, $ok = false; 
                 $cnt < sizeof($lvc_agent_versions['SA']) && !$ok;
                 $cnt++)
            {
                if ($ok = ereg($lvc_agent_versions['SA'][$cnt], $agt))
                {
                    $new_agt .= ';'.$lvc_agent_versions_2['SA'][$cnt];
                    
                    for (@reset($lvc_agent_os), $ok = false;
                         (list($key, $value) = @each($lvc_agent_os)) && !$ok;)
                    {
                        if ($ok = ereg($key, $agt))
                            $new_agt .= ';'.$value;
                    }
                }
            }
    
            if (!$ok) $new_agt = "I";
        }
        else if (ereg('Firefox', $agt) || ereg('BonEcho', $agt) || ereg('Minefield', $agt))  // Firefox
        {
            $new_agt = 'FF';
            $agt = ereg_replace('Mozilla/[0-9]\.[0-9]', 'Mozilla', $agt);

            for ($cnt = 0, $ok = false; 
                 $cnt < sizeof($lvc_agent_versions['FF']) && !$ok;
                 $cnt++)
            {
                if ($ok = ereg($lvc_agent_versions['FF'][$cnt], $agt))
                {
                    $new_agt .= ';'.$lvc_agent_versions['FF'][$cnt];
                    
                    for (@reset($lvc_agent_os), $ok = false;
                         (list($key, $value) = @each($lvc_agent_os)) && !$ok;)
                    {
                        if ($ok = ereg($key, $agt))
                            $new_agt .= ';'.$value;
                    }
                }
            }
    
            if (!$ok) $new_agt = "I";
        }
        elseif (ereg('Opera', $agt))  // Opera
        {
            $new_agt = 'OP';

            for ($cnt = 0, $ok = false; 
                 $cnt < sizeof($lvc_agent_versions['OP']) && !$ok;
                 $cnt++)
            {
                if ($ok = ereg($lvc_agent_versions['OP'][$cnt], $agt))
                {
                    $new_agt .= ';'.$lvc_agent_versions['OP'][$cnt];
                    
                    for (@reset($lvc_agent_os), $ok = false;
                         (list($key, $value) = @each($lvc_agent_os)) && !$ok;)
                    {
                        if ($ok = ereg($key, $agt))
                            $new_agt .= ';'.$value;
                    }
                }
            }
    
            if (!$ok) $new_agt = "I";
        }
        else if ((ereg('MSIE', $agt) || ereg('Internet Explorer', $agt)))  // Internet Explorer
        {
            $new_agt = 'IE';
            $agt = strtr($agt, '_', ' ');

            for ($cnt = 0, $ok = false; 
                 $cnt < sizeof($lvc_agent_versions['IE']) && !$ok;
                 $cnt++)
            {
                if ($ok = ereg($lvc_agent_versions['IE'][$cnt], $agt))
                {
                    $new_agt .= ';'.$lvc_agent_versions['IE'][$cnt];
                    
                    for (@reset($lvc_agent_os), $ok = false;
                         (list($key, $value) = @each($lvc_agent_os)) && !$ok;)
                    {
                        if ($ok = ereg($key, $agt))
                            $new_agt .= ';'.$value;
                    }
                }
            }
    
            if (!$ok) $new_agt = "I";
        }
        elseif (ereg('Mozilla/4.', $agt)) // Netscape 4.x
        {
            $new_agt = 'NS';

            for ($cnt = 0, $ok = false; 
                 $cnt < sizeof($lvc_agent_versions['NS']) && !$ok;
                 $cnt++)
            {
                if ($ok = ereg($lvc_agent_versions['NS'][$cnt], $agt))
                {
                    $new_agt .= ';'.$lvc_agent_versions['NS'][$cnt];
                    
                    for (@reset($lvc_agent_os), $ok = false;
                         (list($key, $value) = @each($lvc_agent_os)) && !$ok;)
                    {
                        if ($ok = ereg($key, $agt))
                            $new_agt .= ';'.$value;
                    }
                }
            }
    
            if (!$ok) $new_agt = "I";
        }
        elseif (ereg('Mozilla/5.0', $agt) && !ereg('Konqueror', $agt)) // NS 6
        {
            $new_agt = 'NS';
    
            for ($cnt = 0, $ok = false; 
                 $cnt < sizeof($lvc_agent_versions['NS6']) && !$ok;
                 $cnt++)
            {
                if ($ok = ereg($lvc_agent_versions['NS6'][$cnt], $agt))
                {
                    $new_agt .= ';'.$lvc_agent_versions_2['NS6'][$cnt];
                    
                    for (@reset($lvc_agent_os), $ok = false;
                         (list($key, $value) = @each($lvc_agent_os)) && !$ok;)
                    {
                        if ($ok = ereg($key, $agt))
                            $new_agt .= ';'.$value;
                    }
                }
            }
    
            if (!$ok) $new_agt = "I";
        }
        if ($new_agt == "I") // others
        {
            $agt = strtolower($agt);
            for (@reset($lvc_other_agt), $ok = false;
                 (list($key, $value) = @each($lvc_other_agt)) && !$ok;)
            {
                if ($ok = (strtolower($key) == $agt || ereg(strtolower($key), $agt)))
                    $new_agt = $value;
            }
    
        }
  
        $new_agt = strip_tags($new_agt);

        if (strlen($new_agt) > $lvc_agent_max_length)
            $new_agt = substr($new_agt, 0, $lvc_agent_max_length-4).' ...';

        return($new_agt);
    }
    // ------------------------------------------------------------------------
  
    $lvc_fai_hosts = Array(
        '9tel.net' => 'FR;Neuf',
        'gaoland.net' => 'FR;Neuf',
        'aol.com' => 'COM;AOL',
        'ac-nantes.fr' => 'FR;education',
        'ac-rouen.fr' => 'FR;education',
        'ac-amiens.fr' => 'FR;education',
        'ac-reims.fr' => 'FR;education',
        'ac-grenoble.fr' => 'FR;education',
        'ac-orleans-tours.fr' => 'FR;education',
        'ac-versailles.fr' => 'FR;education',
        'ac-bordeaux.fr' => 'FR;education',
        'club-internet.fr' => 'FR;Club-Internet',
        'cegetel.net' => 'FR;Cegetel',
        'chello.fr' => 'FR;Chello',
        'evc.net' => 'FR;Evc',
        'easynet.fr' => 'FR;Easynet',
        'proxad.net' => 'FR;Free',
        'numericable.fr' => 'FR;Numericable',
        'modulonet.fr' => 'FR;Numericable',
        'nerim.net' => 'FR;Nerim',
        'noos.fr' => 'FR;Noos',
        'nordnet.fr' => 'FR;Nordnet',
        'tiscali.fr' => 'FR;Tiscali',
        'tele2.fr' => 'FR;Tele2',
        'wanadoo.fr' => 'FR;Wanadoo',
        '\.de$' => 'DE;I',
        '\.at$' => 'AT;I',
        '\.be$' => 'BE;I',
        '\.cy$' => 'CY;I',
        '\.dk$' => 'DK;I',
        '\.es$' => 'ES;I',
        '\.ee$' => 'EE;I',
        '\.fi$' => 'FI;I',
        '\.fr$' => 'FR;I',
        '\.gr$' => 'GR;I',
        '\.hu$' => 'HU;I',
        '\.ie$' => 'IE;I',
        '\.it$' => 'IT;I',
        '\.lv$' => 'LV;I',
        '\.lt$' => 'LT;I',
        '\.lu$' => 'LU;I',
        '\.mt$' => 'MT;I',
        '\.nl$' => 'NL;I',
        '\.pl$' => 'PL;I',
        '\.pt$' => 'PT;I',
        '\.uk$' => 'UK;I',
        '\.sk$' => 'SK;I',
        '\.si$' => 'SI;I',
        '\.se$' => 'SE;I',
        '\.cz$' => 'CZ;I',
        '\.ca$' => 'CA;I',
        '\.ma$' => 'MA;I',
        '\.ch$' => 'CH;I',
        '\.ru$' => 'RU;I',
        '\.jp$' => 'JP;I',
        '\.cr$' => 'CR;I',
        '\.ci$' => 'CI;I',
        '\.cd$' => 'CD;I',
        '\.mg$' => 'MG;I',
        '\.sn$' => 'SN;I',
        '\.info$' => 'INFO;I',
        '\.int$' => 'INT;I',
        '\.biz$' => 'BIZ;I',
        '\.com$' => 'COM;I',
        '\.net$' => 'NET;I',
        '\.org$' => 'ORG;I'
    );

    $lvc_fai = Array(
        'Neuf Telecom' => ';Neuf',
        'AOL' => ';AOL',
        'ducation Nationale' => ';education',
        'Club-Internet' => ';Club-Internet',
        'Cegetel' => ';Cegetel',
        'Chello' => ';Chello',
        'Est Vido Communication' => ';Evc',
        'Easynet' => ';Easynet',
        'Free' => ';Free',
        'Numericable' => ';Numericable',
        'Nerim' => ';Nerim',
        'Noos' => ';Noos',
        'Nordnet' => ';Nordnet',
        'Tiscali' => ';Tiscali',
        'Tele2' => ';Tele2',
        'Orange' => ';Wanadoo'
    );

    $lvc_pays = Array(
        'DE;' => 'Allemagne',
        'AT;' => 'Autriche',
        'BE;' => 'Belgique',
        'CY;' => 'Chypre',
        'DK;' => 'Danemark',
        'ES;' => 'Espagne',
        'EE;' => 'Estonie',
        'FI;' => 'Finlande',
        'FR;' => 'France',
        'GR;' => 'Grce',
        'HU;' => 'Hongrie',
        'IE;' => 'Irlande',
        'IT;' => 'Italie',
        'LV;' => 'Lettonie',
        'LT;' => 'Lituanie',
        'LU;' => 'Luxembourg',
        'MT;' => 'Malte',
        'NL;' => 'Pays-Bas',
        'PL;' => 'Pologne',
        'PT;' => 'Portugal',
        'UK;' => 'Royaume-Uni',
        'SK;' => 'Slovaquie',
        'SI;' => 'Slovnie',
        'SE;' => 'Sude',
        'CZ;' => 'Rpublique Tchque',
        'CA;' => 'Canada',
        'MA;' => 'Maroc',
        'CH;' => 'Suisse',
        'RU;' => 'Russie',
        'JP;' => 'Japon',
        'CR;' => 'Costa Rica',
        'CI;' => 'Cte d\'Ivoire',
        'CD;' => 'Congo',
        'MG;' => 'Madagascar',
        'SN;' => 'Sngal',
        'COM;' => 'Inconnu',
        'INFO;' => 'Inconnu',
        'BIZ;' => 'Inconnu',
        'INY' => 'Inconnu',
        'NET;' => 'Inconnu',
        'ORG;' => 'Inconnu'
    );
// http://techdictionary.com/domainlist.html

    // ------------------------------------------------------------------------
    // extract ISP from HOST ($host)
    // ------------------------------------------------------------------------
    function analyse_host($host, $ip = "127.0.0.1", $debug = 0)
    {
        global $lvc_fai_hosts;

        $fai = "I";

        if ($host == $ip || !ereg("[a-zA-Z]", $host)) {
            $fai = "IP";
        }
        else  // others
        {
            for (@reset($lvc_fai_hosts), $ok = false;
                 (list($key, $value) = @each($lvc_fai_hosts)) && !$ok;)
            {
                if ($ok = ereg($key, $host))
                    $fai = $value;
            }
    
        }

        $fai = strip_tags($fai);

        return($fai);
    }
    // ------------------------------------------------------------------------

  // ------------------------------------------------------------------------- //

}

?>