<?php

// ----------------------------------------------------------------------------
// MODULE: daily_stats
// ----------------------------------------------------------------------------

function module_daily_stats($arguments)
{
    global $gDb;
    
    global $lvc_display_cache_delay;
    global $lvc_table_visitors;

    global $lvm_daily_stats;
    global $lvp_visits, $lvp_hits, $lvp_total, $lvp_bots, $lvp_nbots, $lvp_sign, $lvp_day_direct, $lvp_day_referers;
    global $lvp_day_direct_sign, $lvp_day_referers_sign, $lvp_indic_pv_v_n, $lvp_indic_pv_v, $lvp_indic_pv_v_sign;
    global $lvp_sign_nbots, $lvp_sign_tot, $lvp_type, $lvp_indic;
    
    $date = (!isset($arguments['date']))
                ? date('Y/m/d')
                : str_replace('-', '/', $arguments['date']);

    $buffer  = "<BR><CENTER><TABLE CELLSPACING=1 BORDER=0>\n";
    $buffer .= "<TR><TD COLSPAN=5><A CLASS='array'>".$lvm_daily_stats."</A></TD></TR>\n";
    $buffer .= "<TR><TH></TH><TH COLSPAN=2 CLASS='vis' ALIGN='center'>".$lvp_visits."</TH><TH COLSPAN=2 CLASS='vis' ALIGN='center'>".$lvp_hits."</TH></TR>\n";

    // count visitors
    $query  = "SELECT COUNT(*) AS C, SUM(HITS) AS D ";
    $query .= "FROM ".$lvc_table_visitors." ";
    $query .= "WHERE DATE LIKE '".$date."%'";

    if ($gDb->DbQuery($query) && $gDb->DbNumRows() != 0)
    {
        $gDb->Row = $gDb->DbNextRow();
        $data['visitors'] = $gDb->Row['C'];
        $data['hits'] = $gDb->Row['D'];

        $buffer .= "<TR><TH CLASS='vis' ALIGN='left'>&nbsp;".$lvp_total."&nbsp;</TH>";
        $buffer .= "<TD CLASS='vis' ALIGN='right' COLSPAN=2>&nbsp;<B>".number_format($data['visitors'], 0, ',', ' ')."</B>&nbsp;</TD>\n";
        $buffer .= "<TD CLASS='vis' ALIGN='right' COLSPAN=2>&nbsp;<B>".number_format($data['hits'], 0, ',', ' ')."</B>&nbsp;</TD></TR>\n";
    }
    else
    {
        return('');
    }

    // count BOTs
    $query  = "SELECT COUNT(*) AS C, SUM(HITS) AS D ";
    $query .= "FROM ".$lvc_table_visitors." ";
    $query .= "WHERE DATE LIKE '".$date."%' ";
    $query .= "AND BOT = 1 ";

    if ($gDb->DbQuery($query) && $gDb->DbNumRows() != 0)
    {
        $gDb->Row = $gDb->DbNextRow();
        $data['vbots'] = $gDb->Row['C'];
        $data['hbots'] = $gDb->Row['D'];

        $buffer .= "<TR><TH CLASS='vis' ALIGN='left'>&nbsp;".$lvp_bots."&nbsp;</TH>";
  	    $percent = ($data['visitors'] == 0) ? 0 : round(($data['vbots'] / $data['visitors']) * 1000) / 10;
        $buffer .= "<TD CLASS='vis' ALIGN='right'>&nbsp;".sprintf('%.1f', $percent)." %&nbsp;</TD>\n"; // %
        $buffer .= "<TD CLASS='vis' ALIGN='right'>&nbsp;<B>".number_format($data['vbots'], 0, ',', ' ')."</B>&nbsp;</TD>\n";
  	    $percent = ($data['hits'] == 0) ? 0 : round(($data['hbots'] / $data['hits']) * 1000) / 10;
        $buffer .= "<TD CLASS='vis' ALIGN='right'>&nbsp;".sprintf('%.1f', $percent)." %&nbsp;</TD>\n"; // %
        $buffer .= "<TD CLASS='vis' ALIGN='right'>&nbsp;<B>".number_format($data['hbots'], 0, ',', ' ')."</B>&nbsp;</TD></TR>\n";
        $buffer .= "<TR><TH CLASS='vis' ALIGN='left'>&nbsp;".$lvp_nbots."&nbsp;</TH>";
  	    $percent = ($data['visitors'] == 0) ? 0 : round((($data['visitors'] - $data['vbots']) / $data['visitors']) * 1000) / 10;
        $buffer .= "<TD CLASS='vis' ALIGN='right'>&nbsp;".sprintf('%.1f', $percent)." %&nbsp;</TD>\n"; // %
        $buffer .= "<TD CLASS='vis' ALIGN='right'>&nbsp;<B>".number_format($data['visitors'] - $data['vbots'], 0, ',', ' ')."</B>&nbsp;</TD>\n";
  	    $percent = ($data['hits'] == 0) ? 0 : round((($data['hits'] - $data['hbots']) / $data['hits']) * 1000) / 10;
        $buffer .= "<TD CLASS='vis' ALIGN='right'>&nbsp;".sprintf('%.1f', $percent)." %&nbsp;</TD>\n"; // %
        $buffer .= "<TD CLASS='vis' ALIGN='right'>&nbsp;<B>".number_format($data['hits'] - $data['hbots'], 0, ',', ' ')."</B>&nbsp;</TD></TR>\n";
    }
    else
    {
        return('');
    }

    // count significative visits
    $query  = "SELECT COUNT(*) AS C, SUM(HITS) AS D ";
    $query .= "FROM ".$lvc_table_visitors." ";
    $query .= "WHERE DATE LIKE '".$date."%' ";
    $query .= "AND HITS > 1 AND BOT = 0";

    if ($gDb->DbQuery($query) && $gDb->DbNumRows() != 0)
    {
        $gDb->Row = $gDb->DbNextRow();
        $data['vsign'] = $gDb->Row['C'];
        $data['hsign'] = $gDb->Row['D'];

        $buffer .= "<TR><TH CLASS='vis' ALIGN='left'>&nbsp;".$lvp_sign_tot."&nbsp;</TH>";
  	    $percent = ($data['visitors'] == 0) ? 0 : round(($data['vsign'] / $data['visitors']) * 1000) / 10;
        $buffer .= "<TD CLASS='vis' ALIGN='right'>&nbsp;".sprintf('%.1f', $percent)." %&nbsp;</TD>\n"; // %
        $buffer .= "<TD CLASS='vis' ALIGN='right'>&nbsp;<B>".number_format($data['vsign'], 0, ',', ' ')."</B>&nbsp;</TD>\n";
  	    $percent = ($data['hits'] == 0) ? 0 : round(($data['hsign'] / $data['hits']) * 1000) / 10;
        $buffer .= "<TD CLASS='vis' ALIGN='right'>&nbsp;".sprintf('%.1f', $percent)." %&nbsp;</TD>\n"; // %
        $buffer .= "<TD CLASS='vis' ALIGN='right'>&nbsp;<B>".number_format($data['hsign'], 0, ',', ' ')."</B>&nbsp;</TD></TR>\n";

        $buffer .= "<TR><TH CLASS='vis' ALIGN='left'>&nbsp;".$lvp_sign_nbots."&nbsp;</TH>";
  	    $percent = ($data['visitors'] == 0) ? 0 : round(($data['vsign'] / ($data['visitors'] - $data['vbots'])) * 1000) / 10;
        $buffer .= "<TD CLASS='vis' ALIGN='right'>&nbsp;".sprintf('%.1f', $percent)." %&nbsp;</TD>\n"; // %
        $buffer .= "<TD CLASS='vis' ALIGN='right'>&nbsp;<B>".number_format($data['vsign'], 0, ',', ' ')."</B>&nbsp;</TD>\n";
  	    $percent = ($data['hits'] == 0) ? 0 : round(($data['hsign'] / ($data['hits'] - $data['hbots'])) * 1000) / 10;
        $buffer .= "<TD CLASS='vis' ALIGN='right'>&nbsp;".sprintf('%.1f', $percent)." %&nbsp;</TD>\n"; // %
        $buffer .= "<TD CLASS='vis' ALIGN='right'>&nbsp;<B>".number_format($data['hsign'], 0, ',', ' ')."</B>&nbsp;</TD></TR>\n";
    }
    else
    {
        return('');
    }
    $buffer .= "<TR><TH></TH><TH COLSPAN=4 CLASS='vis' ALIGN='center'>".$lvp_type."</TH></TR>\n";

    // count referers
    $query  = "SELECT COUNT(*) AS C, SUM(HITS) AS D ";
    $query .= "FROM ".$lvc_table_visitors." ";
    $query .= "WHERE DATE LIKE '".$date."%' ";
    $query .= "AND REF_HOST <> '' AND REF_HOST <> '[unknown origin]' AND REF_HOST <> 'bookmarks' AND BOT = 0";

    if ($gDb->DbQuery($query) && $gDb->DbNumRows() != 0)
    {
        $gDb->Row = $gDb->DbNextRow();
        $data['referers'] = $gDb->Row['C'];
        $data['hreferers'] = $gDb->Row['D'];

        $buffer .= "<TR><TH CLASS='vis' ALIGN='left'>&nbsp;".$lvp_day_direct."&nbsp;</TH>";
  	    $percent1 = ($data['visitors'] - $data['vbots'] == 0) ? 0 : round((($data['visitors'] - $data['vbots'] - $data['referers']) / ($data['visitors'] - $data['vbots'])) * 1000) / 10;
        $buffer .= "<TD CLASS='vis' ALIGN='right'>&nbsp;".sprintf('%.1f', $percent1)." %&nbsp;</TD>\n"; // %
        $buffer .= "<TD CLASS='vis' ALIGN='right'>&nbsp;<B>".number_format($data['visitors'] - $data['vbots'] - $data['referers'], 0, ',', ' ')."</B>&nbsp;</TD>\n";
  	    $percent2 = ($data['hits'] - $data['hbots'] == 0) ? 0 : round((($data['hits'] - $data['hbots'] - $data['hreferers']) / ($data['hits'] - $data['hbots'])) * 1000) / 10;
        $buffer .= "<TD CLASS='vis' ALIGN='right'>&nbsp;".sprintf('%.1f', $percent2)." %&nbsp;</TD>\n"; // %
        $buffer .= "<TD CLASS='vis' ALIGN='right'>&nbsp;<B>".number_format($data['hits'] - $data['hbots'] - $data['hreferers'], 0, ',', ' ')."</B>&nbsp;</TD></TR>\n";
        
        $buffer .= "<TR><TH CLASS='vis' ALIGN='left'>&nbsp;".$lvp_day_referers."&nbsp;</TH>";
  	    $percent1 = ($data['visitors'] - $data['vbots'] == 0) ? 0 : 100 - $percent1;
        $buffer .= "<TD CLASS='vis' ALIGN='right'>&nbsp;".sprintf('%.1f', $percent1)." %&nbsp;</TD>\n"; // %
        $buffer .= "<TD CLASS='vis' ALIGN='right'>&nbsp;<B>".number_format($data['referers'], 0, ',', ' ')."</B>&nbsp;</TD>\n";
  	    $percent2 = ($data['visitors'] - $data['hbots'] == 0) ? 0 : 100 - $percent2;
        $buffer .= "<TD CLASS='vis' ALIGN='right'>&nbsp;".sprintf('%.1f', $percent2)." %&nbsp;</TD>\n"; // %
        $buffer .= "<TD CLASS='vis' ALIGN='right'>&nbsp;<B>".number_format($data['hreferers'], 0, ',', ' ')."</B>&nbsp;</TD></TR>\n";
    }
    else
    {
        return('');
    }
    
    // count referers (significative)
    $query  = "SELECT COUNT(*) AS C, SUM(HITS) AS D ";
    $query .= "FROM ".$lvc_table_visitors." ";
    $query .= "WHERE DATE LIKE '".$date."%' ";
    $query .= "AND REF_HOST <> '' AND REF_HOST <> '[unknown origin]' AND REF_HOST <> 'bookmarks' AND BOT = 0 AND HITS > 1";

    if ($gDb->DbQuery($query) && $gDb->DbNumRows() != 0)
    {
        $gDb->Row = $gDb->DbNextRow();
        $data['sreferers'] = $gDb->Row['C'];
        $data['hsreferers'] = $gDb->Row['D'];

        $buffer .= "<TR><TH CLASS='vis' ALIGN='left'>&nbsp;".$lvp_day_direct_sign."&nbsp;</TH>";
  	    $percent1 = ($data['vsign'] == 0) ? 0 : round((($data['vsign'] - $data['sreferers']) / $data['vsign']) * 1000) / 10;
        $buffer .= "<TD CLASS='vis' ALIGN='right'>&nbsp;".sprintf('%.1f', $percent1)." %&nbsp;</TD>\n"; // %
        $buffer .= "<TD CLASS='vis' ALIGN='right'>&nbsp;<B>".number_format($data['vsign'] - $data['sreferers'], 0, ',', ' ')."</B>&nbsp;</TD>\n";
  	    $percent2 = ($data['hsign'] == 0) ? 0 : round((($data['hsign'] - $data['hsreferers']) / $data['hsign']) * 1000) / 10;
        $buffer .= "<TD CLASS='vis' ALIGN='right'>&nbsp;".sprintf('%.1f', $percent2)." %&nbsp;</TD>\n"; // %
        $buffer .= "<TD CLASS='vis' ALIGN='right'>&nbsp;<B>".number_format($data['hsign'] - $data['hsreferers'], 0, ',', ' ')."</B>&nbsp;</TD></TR>\n";
        
        $buffer .= "<TR><TH CLASS='vis' ALIGN='left'>&nbsp;".$lvp_day_referers_sign."&nbsp;</TH>";
  	    $percent1 = ($data['vsign'] == 0) ? 0 : 100 - $percent1;
        $buffer .= "<TD CLASS='vis' ALIGN='right'>&nbsp;".sprintf('%.1f', $percent1)." %&nbsp;</TD>\n"; // %
        $buffer .= "<TD CLASS='vis' ALIGN='right'>&nbsp;<B>".number_format($data['sreferers'], 0, ',', ' ')."</B>&nbsp;</TD>\n";
  	    $percent2 = ($data['hsign'] == 0) ? 0 : 100 - $percent2;
        $buffer .= "<TD CLASS='vis' ALIGN='right'>&nbsp;".sprintf('%.1f', $percent2)." %&nbsp;</TD>\n"; // %
        $buffer .= "<TD CLASS='vis' ALIGN='right'>&nbsp;<B>".number_format($data['hsreferers'], 0, ',', ' ')."</B>&nbsp;</TD></TR>\n";
    }
    else
    {
        return('');
    }
    
    $buffer .= "<TR><TH></TH><TH COLSPAN=4 CLASS='vis' ALIGN='center'>".$lvp_indic."</TH></TR>\n";
    
    // hits/visitors
    $buffer .= "<TR><TH CLASS='vis' ALIGN='left'>&nbsp;".$lvp_indic_pv_v."&nbsp;</TH>";
    $indic = ($data['visitors'] == 0) ? 0 : ($data['hits'] / $data['visitors']);
    $buffer .= "<TD CLASS='vis' ALIGN='center' COLSPAN='4'>&nbsp;<B>".number_format($indic, 2, '.', ' ')."</B>&nbsp;</TD></TR>\n";
    
    // hits/visitors (non-bots)
    $buffer .= "<TR><TH CLASS='vis' ALIGN='left'>&nbsp;".$lvp_indic_pv_v_n."&nbsp;</TH>";
    $indic = ($data['visitors'] - $data['vbots'] == 0) ? 0 : (($data['hits'] - $data['hbots']) / ($data['visitors'] - $data['vbots']));
    $buffer .= "<TD CLASS='vis' ALIGN='center' COLSPAN='4'>&nbsp;<B>".number_format($indic, 2, '.', ' ')."</B>&nbsp;</TD></TR>\n";
    
    // hits/visitors (significative)
    $buffer .= "<TR><TH CLASS='vis' ALIGN='left'>&nbsp;".$lvp_indic_pv_v_sign."&nbsp;</TH>";
    $indic = ($data['vsign'] == 0) ? 0 : ($data['hsign'] / $data['vsign']);
    $buffer .= "<TD CLASS='vis' ALIGN='center' COLSPAN='4'>&nbsp;<B>".number_format($indic, 2, '.', ' ')."</B>&nbsp;</TD></TR>\n";


    // cache delay
    if ($lvc_display_cache_delay)
    {
        $buffer .= "<TR><TD ALIGN='center' COLSPAN='3'>";
        $buffer .= "<A CLASS='delay'>".cache_delay($arguments['cache'])."</A>";
    }

    $buffer .= "</TABLE></CENTER><BR>\n";

    return($buffer);
}

?>