<?php

// ----------------------------------------------------------------------------
// MODULE: daily_stats
// ----------------------------------------------------------------------------

function module_monthly_stats($arguments)
{
    global $gDb;
    
    global $lvc_display_cache_delay;
    global $lvc_table_visitors;

    global $lvp_visits, $lvp_hits, $lvp_total, $lvp_bots, $lvp_nbots, $lvp_sign, $lvp_day_direct, $lvp_day_referers;
    global $lvp_day_direct_sign, $lvp_day_referers_sign, $lvp_indic_pv_v_n, $lvp_indic_pv_v, $lvp_indic_pv_v_sign;
    global $lvp_sign_nbots, $lvp_sign_tot, $lvp_type, $lvp_indic;
    
    global $lvp_monthly_stats;

    $data = archive_month($arguments['month'], $arguments['year'], 'monthly_stats');

    if ($data[0] == NO_ARCHIVE || $data[0] == DB_ERROR) {
        $date = (!isset($arguments['month']) || !isset($arguments['year']))
                ? date('Y/m')
                : $arguments['year'].'/'.$arguments['month'];

        // count visitors
        $query  = "SELECT COUNT(*) AS C, SUM(HITS) AS D ";
        $query .= "FROM ".$lvc_table_visitors." ";
        $query .= "WHERE DATE LIKE '".$date."%'";

        if ($gDb->DbQuery($query) && $gDb->DbNumRows() != 0)
        {
            $gDb->Row = $gDb->DbNextRow();
            $data['vtot'] = $gDb->Row['C'];
            $data['htot'] = $gDb->Row['D'];
        }
        else
        {
            $data['vtot'] = 0;
            $data['htot'] = 0;
        }

        // count BOTs
        $query  = "SELECT COUNT(*) AS C, SUM(HITS) AS D ";
        $query .= "FROM ".$lvc_table_visitors." ";
        $query .= "WHERE DATE LIKE '".$date."%' ";
        $query .= "AND BOT = 1 ";

        if ($gDb->DbQuery($query) && $gDb->DbNumRows() != 0)
        {
            $gDb->Row = $gDb->DbNextRow();
            $data['vbots'] = $gDb->Row['C'];
            $data['hbots'] = $gDb->Row['D'];

        }
        else
        {
            $data['vbots'] = 0;
            $data['hbots'] = 0;
        }

        // count significative visits
        $query  = "SELECT COUNT(*) AS C, SUM(HITS) AS D ";
        $query .= "FROM ".$lvc_table_visitors." ";
        $query .= "WHERE DATE LIKE '".$date."%' ";
        $query .= "AND HITS > 1 AND BOT = 0";

        if ($gDb->DbQuery($query) && $gDb->DbNumRows() != 0)
        {
            $gDb->Row = $gDb->DbNextRow();
            $data['vsig'] = $gDb->Row['C'];
            $data['hsig'] = $gDb->Row['D'];

        }
        else
        {
            $data['vsig'] = 0;
            $data['hsig'] = 0;
        }

        // count referers
        $query  = "SELECT COUNT(*) AS C, SUM(HITS) AS D ";
        $query .= "FROM ".$lvc_table_visitors." ";
        $query .= "WHERE DATE LIKE '".$date."%' ";
        $query .= "AND REF_HOST <> '' AND REF_HOST <> '[unknown origin]' AND REF_HOST <> 'bookmarks' AND BOT = 0";

        if ($gDb->DbQuery($query) && $gDb->DbNumRows() != 0)
        {
            $gDb->Row = $gDb->DbNextRow();
            $data['vnbref'] = $gDb->Row['C'];
            $data['hnbref'] = $gDb->Row['D'];

        }
        else
        {
            $data['vnbref'] = 0;
            $data['hnbref'] = 0;
        }
        
        // count referers (significative)
        $query  = "SELECT COUNT(*) AS C, SUM(HITS) AS D ";
        $query .= "FROM ".$lvc_table_visitors." ";
        $query .= "WHERE DATE LIKE '".$date."%' ";
        $query .= "AND REF_HOST <> '' AND REF_HOST <> '[unknown origin]' AND REF_HOST <> 'bookmarks' AND BOT = 0 AND HITS > 1";

        if ($gDb->DbQuery($query) && $gDb->DbNumRows() != 0)
        {
            $gDb->Row = $gDb->DbNextRow();
            $data['vsigref'] = $gDb->Row['C'];
            $data['hsigref'] = $gDb->Row['D'];

        }
        else
        {
            $data['vsigref'] = 0;
            $data['hsigref'] = 0;
        }
    }
    
    $buffer  = "<BR><CENTER><TABLE CELLSPACING=1 BORDER=0>\n";
    $buffer .= "<TR><TD COLSPAN=5><A CLASS='array'>".$lvp_monthly_stats."</A></TD></TR>\n";
    $buffer .= "<TR><TH></TH><TH COLSPAN=2 CLASS='vis' ALIGN='center'>".$lvp_visits."</TH><TH COLSPAN=2 CLASS='vis' ALIGN='center'>".$lvp_hits."</TH></TR>\n";
    $buffer .= "<TR><TH CLASS='vis' ALIGN='left'>&nbsp;".$lvp_total."&nbsp;</TH>";
    $buffer .= "<TD CLASS='vis' ALIGN='right' COLSPAN=2>&nbsp;<B>".number_format($data['vtot'], 0, ',', ' ')."</B>&nbsp;</TD>\n";
    $buffer .= "<TD CLASS='vis' ALIGN='right' COLSPAN=2>&nbsp;<B>".number_format($data['htot'], 0, ',', ' ')."</B>&nbsp;</TD></TR>\n";
    $buffer .= "<TR><TH CLASS='vis' ALIGN='left'>&nbsp;".$lvp_bots."&nbsp;</TH>";
    $percent = ($data['vtot'] == 0) ? 0 : round(($data['vbots'] / $data['vtot']) * 1000) / 10;
    $buffer .= "<TD CLASS='vis' ALIGN='right'>&nbsp;".sprintf('%.1f', $percent)." %&nbsp;</TD>\n"; // %
    $buffer .= "<TD CLASS='vis' ALIGN='right'>&nbsp;<B>".number_format($data['vbots'], 0, ',', ' ')."</B>&nbsp;</TD>\n";
    $percent = ($data['htot'] == 0) ? 0 : round(($data['hbots'] / $data['htot']) * 1000) / 10;
    $buffer .= "<TD CLASS='vis' ALIGN='right'>&nbsp;".sprintf('%.1f', $percent)." %&nbsp;</TD>\n"; // %
    $buffer .= "<TD CLASS='vis' ALIGN='right'>&nbsp;<B>".number_format($data['hbots'], 0, ',', ' ')."</B>&nbsp;</TD></TR>\n";
    $buffer .= "<TR><TH CLASS='vis' ALIGN='left'>&nbsp;".$lvp_nbots."&nbsp;</TH>";
    $percent = ($data['vtot'] == 0) ? 0 : round((($data['vtot'] - $data['vbots']) / $data['vtot']) * 1000) / 10;
    $buffer .= "<TD CLASS='vis' ALIGN='right'>&nbsp;".sprintf('%.1f', $percent)." %&nbsp;</TD>\n"; // %
    $buffer .= "<TD CLASS='vis' ALIGN='right'>&nbsp;<B>".number_format($data['vtot'] - $data['vbots'], 0, ',', ' ')."</B>&nbsp;</TD>\n";
    $percent = ($data['htot'] == 0) ? 0 : round((($data['htot'] - $data['hbots']) / $data['htot']) * 1000) / 10;
    $buffer .= "<TD CLASS='vis' ALIGN='right'>&nbsp;".sprintf('%.1f', $percent)." %&nbsp;</TD>\n"; // %
    $buffer .= "<TD CLASS='vis' ALIGN='right'>&nbsp;<B>".number_format($data['htot'] - $data['hbots'], 0, ',', ' ')."</B>&nbsp;</TD></TR>\n";
    $buffer .= "<TR><TH CLASS='vis' ALIGN='left'>&nbsp;".$lvp_sign_tot."&nbsp;</TH>";
    $percent = ($data['vtot'] == 0) ? 0 : round(($data['vsig'] / $data['vtot']) * 1000) / 10;
    $buffer .= "<TD CLASS='vis' ALIGN='right'>&nbsp;".sprintf('%.1f', $percent)." %&nbsp;</TD>\n"; // %
    $buffer .= "<TD CLASS='vis' ALIGN='right'>&nbsp;<B>".number_format($data['vsig'], 0, ',', ' ')."</B>&nbsp;</TD>\n";
    $percent = ($data['htot'] == 0) ? 0 : round(($data['hsig'] / $data['htot']) * 1000) / 10;
    $buffer .= "<TD CLASS='vis' ALIGN='right'>&nbsp;".sprintf('%.1f', $percent)." %&nbsp;</TD>\n"; // %
    $buffer .= "<TD CLASS='vis' ALIGN='right'>&nbsp;<B>".number_format($data['hsig'], 0, ',', ' ')."</B>&nbsp;</TD></TR>\n";
    $buffer .= "<TR><TH CLASS='vis' ALIGN='left'>&nbsp;".$lvp_sign_nbots."&nbsp;</TH>";
    $percent = ($data['vtot'] == 0) ? 0 : round(($data['vsig'] / ($data['vtot'] - $data['vbots'])) * 1000) / 10;
    $buffer .= "<TD CLASS='vis' ALIGN='right'>&nbsp;".sprintf('%.1f', $percent)." %&nbsp;</TD>\n"; // %
    $buffer .= "<TD CLASS='vis' ALIGN='right'>&nbsp;<B>".number_format($data['vsig'], 0, ',', ' ')."</B>&nbsp;</TD>\n";
    $percent = ($data['htot'] == 0) ? 0 : round(($data['hsig'] / ($data['htot'] - $data['hbots'])) * 1000) / 10;
    $buffer .= "<TD CLASS='vis' ALIGN='right'>&nbsp;".sprintf('%.1f', $percent)." %&nbsp;</TD>\n"; // %
    $buffer .= "<TD CLASS='vis' ALIGN='right'>&nbsp;<B>".number_format($data['hsig'], 0, ',', ' ')."</B>&nbsp;</TD></TR>\n";
    $buffer .= "<TR><TH></TH><TH COLSPAN=4 CLASS='vis' ALIGN='center'>".$lvp_type."</TH></TR>\n";
    $buffer .= "<TR><TH CLASS='vis' ALIGN='left'>&nbsp;".$lvp_day_direct."&nbsp;</TH>";
    $percent1 = ($data['vtot'] - $date['vbots'] == 0) ? 0 : round((($data['vtot'] - $data['vbots'] - $data['vnbref']) / ($data['vtot'] - $date['vbots'])) * 1000) / 10;
    $buffer .= "<TD CLASS='vis' ALIGN='right'>&nbsp;".sprintf('%.1f', $percent1)." %&nbsp;</TD>\n"; // %
    $buffer .= "<TD CLASS='vis' ALIGN='right'>&nbsp;<B>".number_format($data['vtot'] - $data['vbots'] - $data['vnbref'], 0, ',', ' ')."</B>&nbsp;</TD>\n";
    $percent2 = ($data['htot'] - $date['hbots'] == 0) ? 0 : round((($data['htot'] - $data['hbots'] - $data['hnbref']) / ($data['htot'] - $date['hbots'])) * 1000) / 10;
    $buffer .= "<TD CLASS='vis' ALIGN='right'>&nbsp;".sprintf('%.1f', $percent2)." %&nbsp;</TD>\n"; // %
    $buffer .= "<TD CLASS='vis' ALIGN='right'>&nbsp;<B>".number_format($data['htot'] - $data['hbots'] - $data['hnbref'], 0, ',', ' ')."</B>&nbsp;</TD></TR>\n";
    $buffer .= "<TR><TH CLASS='vis' ALIGN='left'>&nbsp;".$lvp_day_referers."&nbsp;</TH>";
    $percent1 = ($data['vtot'] - $date['vbots'] == 0) ? 0 : 100 - $percent1;
    $buffer .= "<TD CLASS='vis' ALIGN='right'>&nbsp;".sprintf('%.1f', $percent1)." %&nbsp;</TD>\n"; // %
    $buffer .= "<TD CLASS='vis' ALIGN='right'>&nbsp;<B>".number_format($data['vnbref'], 0, ',', ' ')."</B>&nbsp;</TD>\n";
    $percent2 = ($data['vtot'] - $date['hbots'] == 0) ? 0 : 100 - $percent2;
    $buffer .= "<TD CLASS='vis' ALIGN='right'>&nbsp;".sprintf('%.1f', $percent2)." %&nbsp;</TD>\n"; // %
    $buffer .= "<TD CLASS='vis' ALIGN='right'>&nbsp;<B>".number_format($data['hnbref'], 0, ',', ' ')."</B>&nbsp;</TD></TR>\n";
    $buffer .= "<TR><TH CLASS='vis' ALIGN='left'>&nbsp;".$lvp_day_direct_sign."&nbsp;</TH>";
    $percent1 = ($data['vsig'] == 0) ? 0 : round((($data['vsig'] - $data['vsigref']) / $data['vsig']) * 1000) / 10;
    $buffer .= "<TD CLASS='vis' ALIGN='right'>&nbsp;".sprintf('%.1f', $percent1)." %&nbsp;</TD>\n"; // %
    $buffer .= "<TD CLASS='vis' ALIGN='right'>&nbsp;<B>".number_format($data['vsig'] - $data['vsigref'], 0, ',', ' ')."</B>&nbsp;</TD>\n";
    $percent2 = ($data['hsig'] == 0) ? 0 : round((($data['hsig'] - $data['hsigref']) / $data['hsig']) * 1000) / 10;
    $buffer .= "<TD CLASS='vis' ALIGN='right'>&nbsp;".sprintf('%.1f', $percent2)." %&nbsp;</TD>\n"; // %
    $buffer .= "<TD CLASS='vis' ALIGN='right'>&nbsp;<B>".number_format($data['hsig'] - $data['hsigref'], 0, ',', ' ')."</B>&nbsp;</TD></TR>\n";
    $buffer .= "<TR><TH CLASS='vis' ALIGN='left'>&nbsp;".$lvp_day_referers_sign."&nbsp;</TH>";
    $percent1 = ($data['vsig'] == 0) ? 0 : 100 - $percent1;
    $buffer .= "<TD CLASS='vis' ALIGN='right'>&nbsp;".sprintf('%.1f', $percent1)." %&nbsp;</TD>\n"; // %
    $buffer .= "<TD CLASS='vis' ALIGN='right'>&nbsp;<B>".number_format($data['vsigref'], 0, ',', ' ')."</B>&nbsp;</TD>\n";
    $percent2 = ($data['hsig'] == 0) ? 0 : 100 - $percent2;
    $buffer .= "<TD CLASS='vis' ALIGN='right'>&nbsp;".sprintf('%.1f', $percent2)." %&nbsp;</TD>\n"; // %
    $buffer .= "<TD CLASS='vis' ALIGN='right'>&nbsp;<B>".number_format($data['hsigref'], 0, ',', ' ')."</B>&nbsp;</TD></TR>\n";

    $buffer .= "<TR><TH></TH><TH COLSPAN=4 CLASS='vis' ALIGN='center'>".$lvp_indic."</TH></TR>\n";
    
    // hits/visitors
    $buffer .= "<TR><TH CLASS='vis' ALIGN='left'>&nbsp;".$lvp_indic_pv_v."&nbsp;</TH>";
    $indic = ($data['vtot'] == 0) ? 0 : ($data['htot'] / $data['vtot']);
    $buffer .= "<TD CLASS='vis' ALIGN='center' COLSPAN='4'>&nbsp;<B>".number_format($indic, 2, '.', ' ')."</B>&nbsp;</TD></TR>\n";
    
    // hits/visitors (non-bots)
    $buffer .= "<TR><TH CLASS='vis' ALIGN='left'>&nbsp;".$lvp_indic_pv_v_n."&nbsp;</TH>";
    $indic = ($data['vtot'] - $data['vbots'] == 0) ? 0 : (($data['htot'] - $data['hbots']) / ($data['vtot'] - $data['vbots']));
    $buffer .= "<TD CLASS='vis' ALIGN='center' COLSPAN='4'>&nbsp;<B>".number_format($indic, 2, '.', ' ')."</B>&nbsp;</TD></TR>\n";
    
    // hits/visitors (significative)
    $buffer .= "<TR><TH CLASS='vis' ALIGN='left'>&nbsp;".$lvp_indic_pv_v_sign."&nbsp;</TH>";
    $indic = ($data['vsig'] == 0) ? 0 : ($data['hsig'] / $data['vsig']);
    $buffer .= "<TD CLASS='vis' ALIGN='center' COLSPAN='4'>&nbsp;<B>".number_format($indic, 2, '.', ' ')."</B>&nbsp;</TD></TR>\n";

    // cache delay
    if ($lvc_display_cache_delay)
    {
        $buffer .= "<TR><TD ALIGN='center' COLSPAN='3'>";
        $buffer .= "<A CLASS='delay'>".cache_delay($arguments['cache'])."</A>";
    }

    $buffer .= "</TABLE></CENTER><BR>\n";

    return($buffer);
}

?>