<?php

// ------------------------------------------------------------------------- //
// Les Visiteurs - Statistiques de frquentation d'un site web               //
// ------------------------------------------------------------------------- //
// Visitors      - Web site statistics analysis program                      //
// ------------------------------------------------------------------------- //
// Copyright (C) 2000, 2001  J-Pierre DEZELUS <jpdezelus@phpinfo.net>        //
// ------------------------------------------------------------------------- //
//                   phpInfo.net <http://www.phpinfo.net/>                   //
// ------------------------------------------------------------------------- //
//  This program is free software; you can redistribute it and/or modify     //
//  it under the terms of the GNU General Public License as published by     //
//  the Free Software Foundation; either version 2 of the License, or        //
//  (at your option) any later version.                                      //
//                                                                           //
//  This program is distributed in the hope that it will be useful,          //
//  but WITHOUT ANY WARRANTY; without even the implied warranty of           //
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            //
//  GNU General Public License for more details.                             //
//                                                                           //
//  You should have received a copy of the GNU General Public License        //
//  along with this program; if not, write to the Free Software              //
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA //
// ------------------------------------------------------------------------- //

    // ------------------------------------------------------------------------ 
    // configuration file
    // ------------------------------------------------------------------------
    
    // **************************************************************** //
    // ATTENTION                                                        //
    // **************************************************************** //
    // $lvc_include_dir must be set in the file with 'new-visitor' call //
    // **************************************************************** //

    $ignore_messages = true;

    $lvc_config_file = 'config.inc.php3';

    include($lvc_include_dir.$lvc_config_file);
    
    $referer = '';
    $ref_host = '';

    // looking for the cookie
    if ($$lvc_cookie_name == '1')
    {
        // this cookie is only on my machines
        $insert = false;
        setcookie($lvc_cookie_name, '1', time() + (3600*100000));
    }
    else
    {
        $insert = true;
        if (isset($_SERVER["HTTP_REFERER"]))
        {
            for ($cnt = 0; $cnt < sizeof($lvc_ignore_referers) && $insert; $cnt++)
            {
                $insert = $insert && (strtolower(substr($_SERVER["HTTP_REFERER"], 0, strlen($lvc_ignore_referers[$cnt]))) != $lvc_ignore_referers[$cnt]);
            }
            if ($insert)
            {
                $referer = $_SERVER["HTTP_REFERER"];

                $url = parse_url( $referer );
                $ref_host = $url['scheme'].'://'.$url['host'].'/';

                if ($ref_host == ':///')
                    $ref_host = '';
                elseif ($ref_host == 'news:///' || $ref_host == 'news://news/')
                    $ref_host = 'news:';

                for ($cnt = 0; $cnt < sizeof($lvc_remove_referers); $cnt++)
                {
                    if (ereg($lvc_remove_referers[$cnt], $url['host']))
                    {
                        $ref_host = '';
                        break;
                    }
                }
            }
        }
       
        // no insertion for my own machines
        for ($cnt = 0; $cnt < sizeof($lvc_ignore_machines) && $insert; $cnt++)
        {
            $insert = $insert && (!ereg('^'.$lvc_ignore_machines[$cnt], $_SERVER["REMOTE_ADDR"]));
        }
       
        // no insertion if not the good server (test servers for example)
        for ($cnt = 0; $cnt < sizeof($lvc_ignore_servers) && $insert; $cnt++)
        {
            $insert = $insert && ($_SERVER["SERVER_NAME"] != $lvc_ignore_servers[$cnt]);
        }
    }

    $rows_list = 'DATE, ADDR, HOST, AGENT, REFERER, REF_HOST, HITS, BOT, REAL_AGENT, FAI';

    $agent = analyse_agent($_SERVER["HTTP_USER_AGENT"]);
    $real_agent = $_SERVER["HTTP_USER_AGENT"] == "" ? "I" : $_SERVER["HTTP_USER_AGENT"];

    $host = gethostbyaddr($_SERVER["REMOTE_ADDR"]);
    $fai = analyse_host($host, $_SERVER["REMOTE_ADDR"]);

    $is_bot = 0;
    if (ereg("(BOT)", $agent))
    {
        $is_bot = 1;
        $fai = 'B';
    }

    $values_list  = "'" . date('Y/m/d H:i')                       . "',"; // DATE
    $values_list .= "'" . $_SERVER["REMOTE_ADDR"]                 . "',"; // ADDR
    $values_list .= "'" . $host                                   . "',"; // HOST
    $values_list .= "'" . $agent                                  . "',"; // AGENT
    $values_list .= "'" . AddSlashes(strip_tags($referer))        . "',"; // REFERER
    $values_list .= "'" . AddSlashes(strip_tags($ref_host))       . "',"; // REF_HOST
    $values_list .= "1,";                                                 // HITS
    $values_list .= $is_bot . ',';                                        // BOT
    $values_list .= "'" . $real_agent                             . "',"; // AGENT
    $values_list .= "'" . $fai                                     . "'"; // FAI
    $gDb = new Db;
    $connected = $gDb->DbConnect($lvc_db_host, $lvc_db_user, $lvc_db_password, $lvc_db_database);

    if ($insert)
    {
        $found = false;

        if ($connected)
        {
            // does this visitor is in [$lvc_between_2_visits] last visitors ?
            $query = 'SELECT MAX(CODE) FROM '.$lvc_table_visitors;
            if ($gDb->DbQuery($query) && $gDb->DbNumRows() != 0)
            {
                if ($gDb->DbNextRow())
                {
                    $record = $gDb->Row;
                    $max_code = $record[0];
    
                    $query  = 'SELECT HITS, CODE ';
                    $query .= 'FROM '.$lvc_table_visitors.' ';
                    $query .= "WHERE ADDR='".$_SERVER["REMOTE_ADDR"]."' ";
                    $query .= 'AND CODE BETWEEN '.max(0, $max_code - $lvc_between_2_visits + 1).' AND '.$max_code.' AND DATE LIKE \''.date('Y/m/d').'%\'';

                    if ($gDb->DbQuery($query) && $gDb->DbNumRows() != 0)
                    {
                        if ($gDb->DbNextRow())
                        {
                            $record = $gDb->Row;
                            $found = ($record['HITS'] > 0);
                        }
                    }
                }
            }
        }
        if (!$found)
        {
            $query  = 'INSERT INTO '.$lvc_table_visitors.' ('.$rows_list.') VALUES ('.$values_list.')';
            if ($connected)
            {
                $gDb->DbQuery($query);
            }
            else
            {
                $log_file = @fopen($lvc_log_file, 'a');
                if ($log_file)
                {
                    fputs($log_file, $query . ";\n");
                    fclose($log_file);
                }
            }
        }
        else
        {
            $query  = 'UPDATE '.$lvc_table_visitors.' SET HITS = ' . ($record['HITS'] + 1) . ' WHERE CODE = ' . $record['CODE'] .' LIMIT 1';
            if ($connected)
            {
               $gDb->DbQuery($query);
            }
            else
            {
                $log_file = @fopen($lvc_log_file, 'a');
                if ($log_file)
                {
                    fputs($log_file, $query . ";\n");
                    fclose($log_file);
                }
            }
        }
    }
?>